﻿using System;
using System.Windows.Forms;


/*  Multy variable linear regression using Newton optimisation  */
/*                      www.mosismath.com                       */
/*              F(x,y) = (x - 3) *y^2 + (y - 2) * x^2           */
/*                 Minimum at x = 1.832 y = 1.4367              */

namespace WindowsFormsApplication1
{
    

    public partial class Mainwin : Form
    {
        const int features = 2;
       
        double[] gradient = new double[features];
        double[,] hessian = new double[features, features];
        double[] delta = { 10, 10 };
        double x = 4;
        double y = 4;

        Matrix m = new Matrix(features);

        void fillGradient(double x, double y)
        {
            gradient[0] = y * y + 2 * x * (y - 2);
            gradient[1] = 2 * y * (x - 3) + x * x;
        }

        void fillHessian(double x, double y)
        {
            hessian[0, 0] = 2 * (y - 2);
            hessian[0, 1] = 2 * (x + y);
            
            hessian[1, 0] = 2 * (x + y);
            hessian[1, 1] = 2 * (x - 3);
        }

      
        void update_rise()
        {
            fillGradient(x, y);
            fillHessian(x, y);
            // p = p - hessian^-1 * gradient
            m.InitMatrix(hessian);
            m.Invert();
            delta = m.Mult(m.inv, gradient);
            x = x - delta[0];
            y = y - delta[1];
        }


        public Mainwin()
        {
            int i, j;
            DataGridViewCell cell;

            InitializeComponent();
           
            gResult.ColumnCount = features;
            gResult.RowCount = 1;
          
            gData.RowCount = 10;
            gData.ColumnCount = features;
           
            gData.Columns[0].HeaderText = "x";
            gData.Columns[1].HeaderText = "y";

            gResult.Columns[0].HeaderText = "x";
            gResult.Columns[1].HeaderText = "y";
        }


        private void bt_Calc_Click(object sender, EventArgs e)
        {
            int i = 0;
            DataGridViewCell cell;
            while ((Math.Abs(delta[0]) > 1E-5) && (Math.Abs(delta[1]) > 1E-5))
            {
                update_rise();
                if (i < gData.RowCount)
                {
                    gData.Rows[i].HeaderCell.Value = (i+1).ToString();
                    cell = gData[0, i];
                    cell.Value = Math.Round(x, 6).ToString();
                    cell = gData[1, i];
                    cell.Value = Math.Round(y, 6).ToString();
                }
                i++;
            }
            cell = gResult[0, 0];
            cell.Value = Math.Round(x, 4).ToString();
            cell = gResult[1, 0];
            cell.Value = Math.Round(y, 4).ToString();
        }
    }
}
